diff --git a/drivers/net/dsa/microchip/ksz_common.c b/drivers/net/dsa/microchip/ksz_common.c
index 01adcbeffaaa..152f68eda355 100644
--- a/drivers/net/dsa/microchip/ksz_common.c
+++ b/drivers/net/dsa/microchip/ksz_common.c
@@ -1095,7 +1095,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = KSZ8563_CHIP_ID,
 		.dev_name = "KSZ8563",
 		.num_vlans = 4096,
-		.num_alus = 4096,
 		.num_statics = 16,
 		.cpu_ports = 0x07,	/* can be configured as cpu port */
 		.port_cnt = 3,		/* total port count */
@@ -1124,7 +1123,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = KSZ8795_CHIP_ID,
 		.dev_name = "KSZ8795",
 		.num_vlans = 4096,
-		.num_alus = 0,
 		.num_statics = 8,
 		.cpu_ports = 0x10,	/* can be configured as cpu port */
 		.port_cnt = 5,		/* total cpu and user ports */
@@ -1163,7 +1161,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = KSZ8794_CHIP_ID,
 		.dev_name = "KSZ8794",
 		.num_vlans = 4096,
-		.num_alus = 0,
 		.num_statics = 8,
 		.cpu_ports = 0x10,	/* can be configured as cpu port */
 		.port_cnt = 5,		/* total cpu and user ports */
@@ -1188,7 +1185,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = KSZ8765_CHIP_ID,
 		.dev_name = "KSZ8765",
 		.num_vlans = 4096,
-		.num_alus = 0,
 		.num_statics = 8,
 		.cpu_ports = 0x10,	/* can be configured as cpu port */
 		.port_cnt = 5,		/* total cpu and user ports */
@@ -1213,7 +1209,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = KSZ8830_CHIP_ID,
 		.dev_name = "KSZ8863/KSZ8873",
 		.num_vlans = 16,
-		.num_alus = 0,
 		.num_statics = 8,
 		.cpu_ports = 0x4,	/* can be configured as cpu port */
 		.port_cnt = 3,
@@ -1234,7 +1229,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = KSZ9477_CHIP_ID,
 		.dev_name = "KSZ9477",
 		.num_vlans = 4096,
-		.num_alus = 4096,
 		.num_statics = 16,
 		.cpu_ports = 0x7F,	/* can be configured as cpu port */
 		.port_cnt = 7,		/* total physical port count */
@@ -1268,7 +1262,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = KSZ9896_CHIP_ID,
 		.dev_name = "KSZ9896",
 		.num_vlans = 4096,
-		.num_alus = 4096,
 		.num_statics = 16,
 		.cpu_ports = 0x3F,	/* can be configured as cpu port */
 		.port_cnt = 6,		/* total physical port count */
@@ -1301,7 +1294,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = KSZ9897_CHIP_ID,
 		.dev_name = "KSZ9897",
 		.num_vlans = 4096,
-		.num_alus = 4096,
 		.num_statics = 16,
 		.cpu_ports = 0x7F,	/* can be configured as cpu port */
 		.port_cnt = 7,		/* total physical port count */
@@ -1332,7 +1324,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = KSZ9893_CHIP_ID,
 		.dev_name = "KSZ9893",
 		.num_vlans = 4096,
-		.num_alus = 4096,
 		.num_statics = 16,
 		.cpu_ports = 0x07,	/* can be configured as cpu port */
 		.port_cnt = 3,		/* total port count */
@@ -1358,7 +1349,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = KSZ9563_CHIP_ID,
 		.dev_name = "KSZ9563",
 		.num_vlans = 4096,
-		.num_alus = 4096,
 		.num_statics = 16,
 		.cpu_ports = 0x07,	/* can be configured as cpu port */
 		.port_cnt = 3,		/* total port count */
@@ -1385,7 +1375,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = KSZ9567_CHIP_ID,
 		.dev_name = "KSZ9567",
 		.num_vlans = 4096,
-		.num_alus = 4096,
 		.num_statics = 16,
 		.cpu_ports = 0x7F,	/* can be configured as cpu port */
 		.port_cnt = 7,		/* total physical port count */
@@ -1417,7 +1406,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = LAN9370_CHIP_ID,
 		.dev_name = "LAN9370",
 		.num_vlans = 4096,
-		.num_alus = 1024,
 		.num_statics = 256,
 		.cpu_ports = 0x10,	/* can be configured as cpu port */
 		.port_cnt = 5,		/* total physical port count */
@@ -1443,7 +1431,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = LAN9371_CHIP_ID,
 		.dev_name = "LAN9371",
 		.num_vlans = 4096,
-		.num_alus = 1024,
 		.num_statics = 256,
 		.cpu_ports = 0x30,	/* can be configured as cpu port */
 		.port_cnt = 6,		/* total physical port count */
@@ -1469,7 +1456,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = LAN9372_CHIP_ID,
 		.dev_name = "LAN9372",
 		.num_vlans = 4096,
-		.num_alus = 1024,
 		.num_statics = 256,
 		.cpu_ports = 0x30,	/* can be configured as cpu port */
 		.port_cnt = 8,		/* total physical port count */
@@ -1499,7 +1485,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = LAN9373_CHIP_ID,
 		.dev_name = "LAN9373",
 		.num_vlans = 4096,
-		.num_alus = 1024,
 		.num_statics = 256,
 		.cpu_ports = 0x38,	/* can be configured as cpu port */
 		.port_cnt = 5,		/* total physical port count */
@@ -1529,7 +1514,6 @@ const struct ksz_chip_data ksz_switch_chips[] = {
 		.chip_id = LAN9374_CHIP_ID,
 		.dev_name = "LAN9374",
 		.num_vlans = 4096,
-		.num_alus = 1024,
 		.num_statics = 256,
 		.cpu_ports = 0x30,	/* can be configured as cpu port */
 		.port_cnt = 8,		/* total physical port count */
diff --git a/drivers/net/dsa/microchip/ksz_common.h b/drivers/net/dsa/microchip/ksz_common.h
index 8a71e035b699..40c4f5f2d9d5 100644
--- a/drivers/net/dsa/microchip/ksz_common.h
+++ b/drivers/net/dsa/microchip/ksz_common.h
@@ -44,7 +44,6 @@ struct ksz_chip_data {
 	u32 chip_id;
 	const char *dev_name;
 	int num_vlans;
-	int num_alus;
 	int num_statics;
 	int cpu_ports;
 	int port_cnt;